<?php

class InstitucionalController extends ApplicationController 
{
	/*	
		En el caso de que alguien ingrese hasta www.coop.com.py/v1/institucional
		es redireccionado al action principal
	*/
	function index()
	{
		return $this->route_to('action: principal');
	}
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	/*
		El action principal permite mostrar una noticia principal categorizada 
		como destacada y una lista de 3 noticias no destacadas	
	*/
	function principal()
	{
		//-- Noticia principal
		$Noticia = new Noticias();
		$noticiaPrincipal = $Noticia->find_first("columns: id, titulo, descripcion", 
												 "conditions: destacada = 'S' AND portal_id = 1");
		$this->noticiasId = $noticiaPrincipal->id;
		$this->noticiasTitulo = $noticiaPrincipal->titulo;
		$this->noticiasDescripcion = substr($noticiaPrincipal->descripcion, 0, 150) . "...";
		
		//-- Noticias secundarias
		$this->noticiasSecundarias = $Noticia->find("columns: id, titulo", 
													"conditions: destacada = 'N' AND portal_id = 1", 
													"limit: 3", 
													"order: id desc");
	}
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	/*
		El action historia permite ver un texto de la entidad (tabla) datos_estaticos
	*/
	function historia()
	{
		$DatosEstaticos = new DatosEstaticos();
		$this->historia = $DatosEstaticos->find_first("columns: historia")->historia;
	}
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	/*
		El action compromiso permite ver un texto de la entidad (tabla) datos_estaticos
	*/
	function compromiso()
	{
		$DatosEstaticos = new DatosEstaticos();
		$this->compromisoSocial = $DatosEstaticos->find_first("columns: compromiso_social")->compromiso_social;
	}
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	/*
		El action productos muestra una lista de productos de la empresa 
		ordenados alfabeticamente en una tabla recorriendo por COLUMNA, FILA
	*/
	function productos()
	{
		$Producto = new Productos();
																// Datos de Ejemplo
		$cantidadTotal = $Producto->count("id");				// 11
		$cantidadColumna1 = ceil($cantidadTotal / 3);			// 11/3 = 4
		$cantidadTotal = $cantidadTotal - $cantidadColumna1;	// 11-4 = 7
		$cantidadColumna2 = ceil($cantidadTotal / 2);			// 7/2 = 4
		$cantidadColumna3 = $cantidadTotal - $cantidadColumna2;	// 7-4 = 3
		
		
		$this->productosColumna1 = $Producto->find("columns: id, nombre, descripcion, imagen", 
												   "conditions: portal_id = 1", 
												   "order: nombre", 
												   "limit: $cantidadColumna1");
		$in = "";
		foreach($this->productosColumna1 as $producto)
		{
			$in .= $producto->id . ",";
		}
		$in = substr($in, 0, strlen($in) - 1);
		
		$this->productosColumna2 = $Producto->find("columns: id, nombre, descripcion, imagen", 
												   "conditions: portal_id = 1 AND id NOT IN($in)", 
												   "order: nombre", 
												   "limit: $cantidadColumna2");
		$in .= ",";
		foreach($this->productosColumna2 as $producto)
		{
			$in .= $producto->id . ",";
		}
		$in = substr($in, 0, strlen($in) - 1);
												   
		$this->productosColumna3 = $Producto->find("columns: id, nombre, descripcion, imagen", 
												   "conditions: portal_id = 1 AND id NOT IN($in)", 
												   "order: nombre", 
												   "limit: $cantidadColumna3");
	}
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	/*
		El action noticias permite mostrar el detalle de las noticias. Tambin 
		muestra una lista de las ltimas 5 noticias.
	*/
	function noticias()
	{
		//-- Noticia principal
		$Noticia = new Noticias();
		
		//-- muestro la ltima por defecto
		$id = $this->request("id"); 
		if(empty($id))
			$id = $Noticia->maximum(id);
		
		
		$noticiaPrincipal = $Noticia->find($id);
		$noticiaPrincipal = $Noticia->find_first("columns: id, titulo, descripcion, imagen", 
												 "conditions: id = $id");
		$this->noticiasTitulo = $noticiaPrincipal->titulo;
		$this->noticiasDescripcion = $noticiaPrincipal->descripcion;
		$this->noticiasImagen = $noticiaPrincipal->imagen;
		
		
		//-- Noticias secundarias
		$this->noticiasSecundarias = $Noticia->find("columns: id, titulo", 
													"conditions: portal_id = 1",
													"limit: 5", 
													"order: id desc");													
	}
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	/*
		El action contacto solo permite ver el formulario de envio de mails.
		Est unido muy fuertemente con el action enviarMail que utiliza funcionalidades
		de la libreria mailSender ubicada en /v1/lib/mail/mailSender.php clase que cree 
		para reutilizar cdigo (sta a su vez utiliza la libreria de phpmailer). La clase 
		mailSender devuelve un array de dos posiciones. La primera con un valor booleano 
		que permite saber si el mail fue enviado y la segunda especificando el mensaje. 
		En el case de ser true una confirmacin y el case de ser false un error propio
		del phpmailer.
		
		Tambin utilizo una librera que cree para escribir en modo de ejecucin cdigo
		javascript. En este caso para mostrar un alert() con el mensaje del mailSender		
	*/ 
	function contacto()
	{

	}
	
	public function enviarMail()
	{
		Kumbia::import('lib.mail.mailSender');
        Kumbia::import('lib.micayael.functions_js_v1');
        
        $Cgrefcodes = new Cgrefcodes();
        $from = $this->request("email");
        $fromName = $this->request("nombre") . " " . $this->request("apellido");
        $host = $Cgrefcodes->find_first("columns: descripcion", "conditions: dominio = 'HOST_MAIL'")->descripcion;
        $subject = $Cgrefcodes->find_first("columns: descripcion", "conditions: dominio = 'ASUNTO_MAIL'")->descripcion;
        $to = $Cgrefcodes->find_first("columns: descripcion", "conditions: dominio = 'MAIL_INFO'")->descripcion;
        $body = $this->request("mensaje");

        $mail = new mailSender($from, $fromName, $host, $subject, $to, $body);
		$msg = $mail->enviar();
		
		if($msg[0])
			alerta($msg[1]);
		else
			alerta("ERROR: " . $msg[1]);
			
		return $this->route_to('action: contacto');
    }
	
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

}

?>